diff --git a/gcc/java/lang.c b/gcc/java/lang.c
index 8a68691..da68fc7 100644
--- a/gcc/java/lang.c
+++ b/gcc/java/lang.c
@@ -231,7 +231,7 @@ java_handle_option (size_t scode, const char *arg, int value,
       flag_wall = value;
       /* When -Wall given, enable -Wunused.  We do this because the C
 	 compiler does it, and people expect it.  */
-      warn_unused = value;
+      GCC_OPTION (warn_unused) = value;
       break;
 
     case OPT_fenable_assertions_:
@@ -313,11 +313,11 @@ java_init (void)
 {
   /* FIXME: Indirect dispatch isn't yet compatible with static class
      init optimization.  */
-  if (flag_indirect_dispatch)
+  if (GCC_OPTION (flag_indirect_dispatch))
     always_initialize_class_p = true;
 
-  if (!flag_indirect_dispatch)
-    flag_indirect_classes = false;
+  if (!GCC_OPTION (flag_indirect_dispatch))
+    GCC_OPTION (flag_indirect_classes) = false;
 
   jcf_path_seal (v_flag);
 
@@ -579,22 +579,22 @@ java_post_options (const char **pfilename)
 
   /* Excess precision other than "fast" requires front-end
      support.  */
-  if (flag_excess_precision_cmdline == EXCESS_PRECISION_STANDARD
+  if (GCC_OPTION (flag_excess_precision_cmdline) == EXCESS_PRECISION_STANDARD
       && TARGET_FLT_EVAL_METHOD_NON_DEFAULT)
     sorry ("-fexcess-precision=standard for Java");
-  flag_excess_precision_cmdline = EXCESS_PRECISION_FAST;
+  GCC_OPTION (flag_excess_precision_cmdline) = EXCESS_PRECISION_FAST;
 
   /* An absolute requirement: if we're not using indirect dispatch, we
      must always verify everything.  */
-  if (! flag_indirect_dispatch)
+  if (! GCC_OPTION (flag_indirect_dispatch))
     flag_verify_invocations = true;
 
-  if (flag_reduced_reflection)
+  if (GCC_OPTION (flag_reduced_reflection))
     {
-      if (flag_indirect_dispatch)
+      if (GCC_OPTION (flag_indirect_dispatch))
         error ("-findirect-dispatch is incompatible "
                "with -freduced-reflection");
-      if (flag_jni)
+      if (GCC_OPTION (flag_jni))
         error ("-fjni is incompatible with -freduced-reflection");
     }
 
diff --git a/gcc/java/parse.h b/gcc/java/parse.h
index 2bd03ea..f3c9276 100644
--- a/gcc/java/parse.h
+++ b/gcc/java/parse.h
@@ -31,7 +31,7 @@ extern struct obstack temporary_obstack;
 #ifdef VERBOSE_SKELETON
 #undef SOURCE_FRONTEND_DEBUG
 #define SOURCE_FRONTEND_DEBUG(X)				\
-  {if (!quiet_flag) {printf ("* "); printf X; putchar ('\n');} }
+  {if (!GCC_OPTION (quiet_flag)) {printf ("* "); printf X; putchar ('\n');} }
 #else
 #define SOURCE_FRONTEND_DEBUG(X)
 #endif
diff --git a/gcc/java/typeck.c b/gcc/java/typeck.c
index 574029a..96d58ed 100644
--- a/gcc/java/typeck.c
+++ b/gcc/java/typeck.c
@@ -129,7 +129,7 @@ convert (tree type, tree expr)
     {
       if (type == char_type_node || type == promoted_char_type_node)
 	return fold_convert (type, expr);
-      if ((really_constant_p (expr) || ! flag_unsafe_math_optimizations)
+      if ((really_constant_p (expr) || ! GCC_OPTION (flag_unsafe_math_optimizations))
 	  && TREE_CODE (TREE_TYPE (expr)) == REAL_TYPE)
 	return convert_ieee_real_to_integer (type, expr);
       else
diff --git a/gcc/java/verify-glue.c b/gcc/java/verify-glue.c
index f0e1e4f..09025b2 100644
--- a/gcc/java/verify-glue.c
+++ b/gcc/java/verify-glue.c
@@ -223,7 +223,7 @@ vfy_is_assignable_from (vfy_jclass target, vfy_jclass source)
     return true;
 
   /* For the C++ ABI, perform this test statically. */
-  if (! flag_indirect_dispatch)
+  if (! GCC_OPTION (flag_indirect_dispatch))
     return can_widen_reference_to (source, target);
 
   /* For the BC-ABI, we assume at compile time that reference types are always 
diff --git a/gcc/langhooks.c b/gcc/langhooks.c
index d00ebd8..8d61015 100644
--- a/gcc/langhooks.c
+++ b/gcc/langhooks.c
@@ -110,7 +110,7 @@ lhd_post_options (const char ** ARG_UNUSED (pfilename))
 {
   /* Excess precision other than "fast" requires front-end
      support.  */
-  flag_excess_precision_cmdline = EXCESS_PRECISION_FAST;
+  GCC_OPTION (flag_excess_precision_cmdline) = EXCESS_PRECISION_FAST;
   return false;
 }
 
diff --git a/gcc/loop-init.c b/gcc/loop-init.c
index 2c2c269..b0c3fd4 100644
--- a/gcc/loop-init.c
+++ b/gcc/loop-init.c
@@ -293,13 +293,13 @@ fix_loop_structure (bitmap changed_bbs)
 static bool
 gate_handle_loop2 (void)
 {
-  if (optimize > 0
-      && (flag_move_loop_invariants
-	  || flag_unswitch_loops
-	  || flag_peel_loops
-	  || flag_unroll_loops
+  if (GCC_OPTION (optimize) > 0
+      && (GCC_OPTION (flag_move_loop_invariants)
+	  || GCC_OPTION (flag_unswitch_loops)
+	  || GCC_OPTION (flag_peel_loops)
+	  || GCC_OPTION (flag_unroll_loops)
 #ifdef HAVE_doloop_end
-	  || (flag_branch_on_count_reg && HAVE_doloop_end)
+	  || (GCC_OPTION (flag_branch_on_count_reg) && HAVE_doloop_end)
 #endif
 	 ))
     return true;
@@ -467,7 +467,7 @@ make_pass_rtl_loop_done (gcc::context *ctxt)
 static bool
 gate_rtl_move_loop_invariants (void)
 {
-  return flag_move_loop_invariants;
+  return GCC_OPTION (flag_move_loop_invariants);
 }
 
 static unsigned int
@@ -522,7 +522,7 @@ make_pass_rtl_move_loop_invariants (gcc::context *ctxt)
 static bool
 gate_rtl_unswitch (void)
 {
-  return flag_unswitch_loops;
+  return GCC_OPTION (flag_unswitch_loops);
 }
 
 static unsigned int
@@ -576,7 +576,7 @@ make_pass_rtl_unswitch (gcc::context *ctxt)
 static bool
 gate_rtl_unroll_and_peel_loops (void)
 {
-  return (flag_peel_loops || flag_unroll_loops || flag_unroll_all_loops);
+  return (GCC_OPTION (flag_peel_loops) || GCC_OPTION (flag_unroll_loops) || GCC_OPTION (flag_unroll_all_loops));
 }
 
 static unsigned int
@@ -588,11 +588,11 @@ rtl_unroll_and_peel_loops (void)
       if (dump_file)
 	df_dump (dump_file);
 
-      if (flag_peel_loops)
+      if (GCC_OPTION (flag_peel_loops))
 	flags |= UAP_PEEL;
-      if (flag_unroll_loops)
+      if (GCC_OPTION (flag_unroll_loops))
 	flags |= UAP_UNROLL;
-      if (flag_unroll_all_loops)
+      if (GCC_OPTION (flag_unroll_all_loops))
 	flags |= UAP_UNROLL_ALL;
 
       unroll_and_peel_loops (flags);
@@ -644,7 +644,7 @@ static bool
 gate_rtl_doloop (void)
 {
 #ifdef HAVE_doloop_end
-  return (flag_branch_on_count_reg && HAVE_doloop_end);
+  return (GCC_OPTION (flag_branch_on_count_reg) && HAVE_doloop_end);
 #else
   return 0;
 #endif
diff --git a/gcc/loop-invariant.c b/gcc/loop-invariant.c
index 100a2c1..b007ce1 100644
--- a/gcc/loop-invariant.c
+++ b/gcc/loop-invariant.c
@@ -1073,7 +1073,7 @@ get_inv_cost (struct invariant *inv, int *comp_cost, unsigned *regs_needed)
   inv = invariants[inv->eqto];
 
   *comp_cost = 0;
-  if (! flag_ira_loop_pressure)
+  if (! GCC_OPTION (flag_ira_loop_pressure))
     regs_needed[0] = 0;
   else
     {
@@ -1086,7 +1086,7 @@ get_inv_cost (struct invariant *inv, int *comp_cost, unsigned *regs_needed)
     return;
   inv->stamp = actual_stamp;
 
-  if (! flag_ira_loop_pressure)
+  if (! GCC_OPTION (flag_ira_loop_pressure))
     regs_needed[0]++;
   else
     {
@@ -1124,7 +1124,7 @@ get_inv_cost (struct invariant *inv, int *comp_cost, unsigned *regs_needed)
 	&& IS_STACK_MODE (GET_MODE (SET_SRC (set)))
 	&& constant_pool_constant_p (SET_SRC (set)))
       {
-	if (flag_ira_loop_pressure)
+	if (GCC_OPTION (flag_ira_loop_pressure))
 	  regs_needed[ira_stack_reg_pressure_class] += 2;
 	else
 	  regs_needed[0] += 2;
@@ -1140,7 +1140,7 @@ get_inv_cost (struct invariant *inv, int *comp_cost, unsigned *regs_needed)
 
       get_inv_cost (dep, &acomp_cost, aregs_needed);
 
-      if (! flag_ira_loop_pressure)
+      if (! GCC_OPTION (flag_ira_loop_pressure))
 	check_p = aregs_needed[0] != 0;
       else
 	{
@@ -1159,7 +1159,7 @@ get_inv_cost (struct invariant *inv, int *comp_cost, unsigned *regs_needed)
 	{
 	  /* If this is a single use, after moving the dependency we will not
 	     need a new register.  */
-	  if (! flag_ira_loop_pressure)
+	  if (! GCC_OPTION (flag_ira_loop_pressure))
 	    aregs_needed[0]--;
 	  else
 	    {
@@ -1171,7 +1171,7 @@ get_inv_cost (struct invariant *inv, int *comp_cost, unsigned *regs_needed)
 	    }
 	}
 
-      if (! flag_ira_loop_pressure)
+      if (! GCC_OPTION (flag_ira_loop_pressure))
 	regs_needed[0] += aregs_needed[0];
       else
 	{
@@ -1200,7 +1200,7 @@ gain_for_invariant (struct invariant *inv, unsigned *regs_needed,
 
   get_inv_cost (inv, &comp_cost, regs_needed);
 
-  if (! flag_ira_loop_pressure)
+  if (! GCC_OPTION (flag_ira_loop_pressure))
     {
       size_cost = (estimate_reg_pressure_cost (new_regs[0] + regs_needed[0],
 					       regs_used, speed, call_p)
@@ -1282,7 +1282,7 @@ best_gain_for_invariant (struct invariant **best, unsigned *regs_needed,
 	{
 	  gain = again;
 	  *best = inv;
-	  if (! flag_ira_loop_pressure)
+	  if (! GCC_OPTION (flag_ira_loop_pressure))
 	    regs_needed[0] = aregs_needed[0];
 	  else
 	    {
@@ -1339,7 +1339,7 @@ find_invariants_to_move (bool speed, bool call_p)
   if (!invariants.length ())
     return;
 
-  if (flag_ira_loop_pressure)
+  if (GCC_OPTION (flag_ira_loop_pressure))
     /* REGS_USED is actually never used when the flag is on.  */
     regs_used = 0;
   else
@@ -1361,7 +1361,7 @@ find_invariants_to_move (bool speed, bool call_p)
 	}
     }
 
-  if (! flag_ira_loop_pressure)
+  if (! GCC_OPTION (flag_ira_loop_pressure))
     new_regs[0] = regs_needed[0] = 0;
   else
     {
@@ -1373,7 +1373,7 @@ find_invariants_to_move (bool speed, bool call_p)
 					  speed, call_p)) > 0)
     {
       set_move_mark (inv->invno, gain);
-      if (! flag_ira_loop_pressure)
+      if (! GCC_OPTION (flag_ira_loop_pressure))
 	new_regs[0] += regs_needed[0];
       else
 	{
@@ -1523,7 +1523,7 @@ move_invariants (struct loop *loop)
 
   FOR_EACH_VEC_ELT (invariants, i, inv)
     move_invariant_reg (loop, i);
-  if (flag_ira_loop_pressure && resize_reg_info ())
+  if (GCC_OPTION (flag_ira_loop_pressure) && resize_reg_info ())
     {
       FOR_EACH_VEC_ELT (invariants, i, inv)
 	if (inv->reg != NULL_RTX)
@@ -1872,8 +1872,8 @@ calculate_loop_reg_pressure (void)
 	}
     }
   bitmap_clear (&curr_regs_live);
-  if (flag_ira_region == IRA_REGION_MIXED
-      || flag_ira_region == IRA_REGION_ALL)
+  if (GCC_OPTION (flag_ira_region) == IRA_REGION_MIXED
+      || GCC_OPTION (flag_ira_region) == IRA_REGION_ALL)
     FOR_EACH_LOOP (loop, 0)
       {
 	EXECUTE_IF_SET_IN_BITMAP (&LOOP_DATA (loop)->regs_live, 0, j, bi)
@@ -1924,7 +1924,7 @@ move_loop_invariants (void)
 {
   struct loop *loop;
 
-  if (flag_ira_loop_pressure)
+  if (GCC_OPTION (flag_ira_loop_pressure))
     {
       df_analyze ();
       regstat_init_n_sets_and_refs ();
@@ -1948,7 +1948,7 @@ move_loop_invariants (void)
       free_loop_data (loop);
     }
 
-  if (flag_ira_loop_pressure)
+  if (GCC_OPTION (flag_ira_loop_pressure))
     /* There is no sense to keep this info because it was most
        probably outdated by subsequent passes.  */
     free_reg_info ();
diff --git a/gcc/loop-iv.c b/gcc/loop-iv.c
index 9091220..8d6144b 100644
--- a/gcc/loop-iv.c
+++ b/gcc/loop-iv.c
@@ -3032,12 +3032,12 @@ get_simple_loop_desc (struct loop *loop)
 
       /* Assume that no overflow happens and that the loop is finite.
 	 We already warned at the tree level if we ran optimizations there.  */
-      if (!flag_tree_loop_optimize && warn_unsafe_loop_optimizations)
+      if (!GCC_OPTION (flag_tree_loop_optimize) && GCC_OPTION (warn_unsafe_loop_optimizations))
 	{
 	  if (desc->infinite)
 	    {
 	      wording =
-		flag_unsafe_loop_optimizations
+		GCC_OPTION (flag_unsafe_loop_optimizations)
 		? N_("assuming that the loop is not infinite")
 		: N_("cannot optimize possibly infinite loops");
 	      warning (OPT_Wunsafe_loop_optimizations, "%s",
@@ -3046,7 +3046,7 @@ get_simple_loop_desc (struct loop *loop)
 	  if (desc->assumptions)
 	    {
 	      wording =
-		flag_unsafe_loop_optimizations
+		GCC_OPTION (flag_unsafe_loop_optimizations)
 		? N_("assuming that the loop counter does not overflow")
 		: N_("cannot optimize loop, the loop counter may overflow");
 	      warning (OPT_Wunsafe_loop_optimizations, "%s",
@@ -3054,7 +3054,7 @@ get_simple_loop_desc (struct loop *loop)
 	    }
 	}
 
-      if (flag_unsafe_loop_optimizations)
+      if (GCC_OPTION (flag_unsafe_loop_optimizations))
 	{
 	  desc->assumptions = NULL_RTX;
 	  desc->infinite = NULL_RTX;
diff --git a/gcc/loop-unroll.c b/gcc/loop-unroll.c
index 4561ce8..8e19c68 100644
--- a/gcc/loop-unroll.c
+++ b/gcc/loop-unroll.c
@@ -595,7 +595,7 @@ peel_loop_completely (struct loop *loop)
 	bitmap_clear_bit (wont_exit, 1);
 
       auto_vec<edge> remove_edges;
-      if (flag_split_ivs_in_unroller)
+      if (GCC_OPTION (flag_split_ivs_in_unroller))
         opt_info = analyze_insns_in_loop (loop);
 
       opt_info_start_duplication (opt_info);
@@ -778,8 +778,8 @@ unroll_loop_constant_iterations (struct loop *loop)
   bitmap_ones (wont_exit);
 
   auto_vec<edge> remove_edges;
-  if (flag_split_ivs_in_unroller
-      || flag_variable_expansion_in_unroller)
+  if (GCC_OPTION (flag_split_ivs_in_unroller)
+      || GCC_OPTION (flag_variable_expansion_in_unroller))
     opt_info = analyze_insns_in_loop (loop);
 
   if (!exit_at_end)
@@ -1108,8 +1108,8 @@ unroll_loop_runtime_iterations (struct loop *loop)
   struct opt_info *opt_info = NULL;
   bool ok;
 
-  if (flag_split_ivs_in_unroller
-      || flag_variable_expansion_in_unroller)
+  if (GCC_OPTION (flag_split_ivs_in_unroller)
+      || GCC_OPTION (flag_variable_expansion_in_unroller))
     opt_info = analyze_insns_in_loop (loop);
 
   /* Remember blocks whose dominators will have to be updated.  */
@@ -1441,7 +1441,7 @@ peel_loop_simple (struct loop *loop)
   struct opt_info *opt_info = NULL;
   bool ok;
 
-  if (flag_split_ivs_in_unroller && npeel > 1)
+  if (GCC_OPTION (flag_split_ivs_in_unroller) && npeel > 1)
     opt_info = analyze_insns_in_loop (loop);
 
   wont_exit = sbitmap_alloc (npeel + 1);
@@ -1593,8 +1593,8 @@ unroll_loop_stupid (struct loop *loop)
   struct opt_info *opt_info = NULL;
   bool ok;
 
-  if (flag_split_ivs_in_unroller
-      || flag_variable_expansion_in_unroller)
+  if (GCC_OPTION (flag_split_ivs_in_unroller)
+      || GCC_OPTION (flag_variable_expansion_in_unroller))
     opt_info = analyze_insns_in_loop (loop);
 
 
@@ -1738,10 +1738,10 @@ analyze_insn_to_expand_var (struct loop *loop, rtx insn)
 
   if (FLOAT_MODE_P (GET_MODE (dest)))
     {
-      if (!flag_associative_math)
+      if (!GCC_OPTION (flag_associative_math))
         return NULL;
       /* In the case of FMA, we're also changing the rounding.  */
-      if (code == FMA && !flag_unsafe_math_optimizations)
+      if (code == FMA && !GCC_OPTION (flag_unsafe_math_optimizations))
 	return NULL;
     }
 
@@ -1929,7 +1929,7 @@ analyze_insns_in_loop (struct loop *loop)
 
   body = get_loop_body (loop);
 
-  if (flag_split_ivs_in_unroller)
+  if (GCC_OPTION (flag_split_ivs_in_unroller))
     {
       opt_info->insns_to_split.create (5 * loop->num_nodes);
       opt_info->iv_to_split_head = NULL;
@@ -1949,7 +1949,7 @@ analyze_insns_in_loop (struct loop *loop)
 	}
     }
 
-  if (flag_variable_expansion_in_unroller
+  if (GCC_OPTION (flag_variable_expansion_in_unroller)
       && can_apply)
     {
       opt_info->insns_with_var_to_expand.create (5 * loop->num_nodes);
diff --git a/gcc/lower-subreg.c b/gcc/lower-subreg.c
index a1331c0..3b4a845 100644
--- a/gcc/lower-subreg.c
+++ b/gcc/lower-subreg.c
@@ -1692,7 +1692,7 @@ decompose_multiword_subregs (bool decompose_copies)
 static bool
 gate_handle_lower_subreg (void)
 {
-  return flag_split_wide_types != 0;
+  return GCC_OPTION (flag_split_wide_types) != 0;
 }
 
 /* Implement first lower subreg pass.  */
diff --git a/gcc/lra-constraints.c b/gcc/lra-constraints.c
index ba4d489..cbf295c 100644
--- a/gcc/lra-constraints.c
+++ b/gcc/lra-constraints.c
@@ -1461,7 +1461,7 @@ spilled_pseudo_p (rtx op)
 static inline bool
 general_constant_p (rtx x)
 {
-  return CONSTANT_P (x) && (! flag_pic || LEGITIMATE_PIC_OPERAND_P (x));
+  return CONSTANT_P (x) && (! GCC_OPTION (flag_pic) || LEGITIMATE_PIC_OPERAND_P (x));
 }
 
 static bool
diff --git a/gcc/lra-spills.c b/gcc/lra-spills.c
index 50f63fc..c922a25 100644
--- a/gcc/lra-spills.c
+++ b/gcc/lra-spills.c
@@ -382,7 +382,7 @@ assign_stack_slot_num_and_sort_pseudos (int *pseudo_regnos, int n)
   for (i = 0; i < n; i++)
     {
       regno = pseudo_regnos[i];
-      if (! flag_ira_share_spill_slots)
+      if (! GCC_OPTION (flag_ira_share_spill_slots))
 	j = slots_num;
       else
 	{
diff --git a/gcc/lra.c b/gcc/lra.c
index 77074e2..bda8910 100644
--- a/gcc/lra.c
+++ b/gcc/lra.c
@@ -2092,7 +2092,7 @@ has_nonexceptional_receiver (void)
   basic_block *tos, *worklist, bb;
 
   /* If we're not optimizing, then just err on the safe side.  */
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     return true;
 
   /* First determine which blocks can reach exit via normal paths.  */
diff --git a/gcc/lto-cgraph.c b/gcc/lto-cgraph.c
index ef3890d..10ff2da 100644
--- a/gcc/lto-cgraph.c
+++ b/gcc/lto-cgraph.c
@@ -666,7 +666,7 @@ output_profile_summary (struct lto_simple_output_block *ob)
          }
       /* IPA-profile computes hot bb threshold based on cumulated
 	 whole program profile.  We need to stream it down to ltrans.  */
-       if (flag_wpa)
+       if (GCC_OPTION (flag_wpa))
          streamer_write_gcov_count_stream (ob->main_stream,
 					   get_hot_bb_threshold ());
     }
@@ -846,7 +846,7 @@ compute_ltrans_boundary (lto_symtab_encoder_t in_encoder)
 	    }
 	}
       /* Add all possible targets for late devirtualization.  */
-      if (flag_devirtualize)
+      if (GCC_OPTION (flag_devirtualize))
 	for (edge = node->indirect_calls; edge; edge = edge->next_callee)
 	  if (edge->indirect_info->polymorphic)
 	    {
@@ -892,7 +892,7 @@ output_symtab (void)
   int i, n_nodes;
   lto_symtab_encoder_t encoder;
 
-  if (flag_wpa)
+  if (GCC_OPTION (flag_wpa))
     output_cgraph_opt_summary ();
 
   ob = lto_create_simple_output_block (LTO_section_symtab_nodes);
@@ -1406,7 +1406,7 @@ input_profile_summary (struct lto_input_block *ib,
         }
       /* IPA-profile computes hot bb threshold based on cumulated
 	 whole program profile.  We need to stream it down to ltrans.  */
-      if (flag_ltrans)
+      if (GCC_OPTION (flag_ltrans))
 	set_hot_bb_threshold (streamer_read_gcov_count (ib));
     }
 
@@ -1511,7 +1511,7 @@ merge_profile_summaries (struct lto_file_decl_data **file_data_vec)
     lto_gcov_summary.sum_max = max_runs;
 
   /* If merging already happent at WPA time, we are done.  */
-  if (flag_ltrans)
+  if (GCC_OPTION (flag_ltrans))
     return;
 
   /* Now compute count_materialization_scale of each node.
@@ -1574,7 +1574,7 @@ input_symtab (void)
       input_refs (ib, nodes);
       lto_destroy_simple_input_block (file_data, LTO_section_refs,
 				      ib, data, len);
-      if (flag_ltrans)
+      if (GCC_OPTION (flag_ltrans))
 	input_cgraph_opt_summary (nodes);
       nodes.release ();
     }
diff --git a/gcc/lto-compress.c b/gcc/lto-compress.c
index 4d718d5..ec2c57d 100644
--- a/gcc/lto-compress.c
+++ b/gcc/lto-compress.c
@@ -83,7 +83,7 @@ lto_zfree (void *opaque, void *address)
 static int
 lto_normalized_zlib_level (void)
 {
-  int level = flag_lto_compression_level;
+  int level = GCC_OPTION (flag_lto_compression_level);
 
   if (level != Z_DEFAULT_COMPRESSION)
     {
diff --git a/gcc/lto-section-in.c b/gcc/lto-section-in.c
index 9aa7639..d951df9 100644
--- a/gcc/lto-section-in.c
+++ b/gcc/lto-section-in.c
@@ -153,7 +153,7 @@ lto_get_section_data (struct lto_file_decl_data *file_data,
 
   /* FIXME lto: WPA mode does not write compressed sections, so for now
      suppress uncompression if flag_ltrans.  */
-  if (!flag_ltrans)
+  if (!GCC_OPTION (flag_ltrans))
     {
       /* Create a mapping header containing the underlying data and length,
 	 and prepend this to the uncompression buffer.  The uncompressed data
@@ -200,7 +200,7 @@ lto_free_section_data (struct lto_file_decl_data *file_data,
 
   /* FIXME lto: WPA mode does not write compressed sections, so for now
      suppress uncompression mapping if flag_ltrans.  */
-  if (flag_ltrans)
+  if (GCC_OPTION (flag_ltrans))
     {
       (free_section_f) (file_data, section_type, name, data, len);
       return;
diff --git a/gcc/lto-section-out.c b/gcc/lto-section-out.c
index 9d6926c..677687c 100644
--- a/gcc/lto-section-out.c
+++ b/gcc/lto-section-out.c
@@ -342,7 +342,7 @@ lto_destroy_simple_output_block (struct lto_simple_output_block *ob)
   struct lto_output_stream *header_stream;
 
   section_name = lto_get_section_name (ob->section_type, NULL, NULL);
-  lto_begin_section (section_name, !flag_wpa);
+  lto_begin_section (section_name, !GCC_OPTION (flag_wpa));
   free (section_name);
 
   /* Write the header which says how to decode the pieces of the
diff --git a/gcc/lto-streamer-in.c b/gcc/lto-streamer-in.c
index 3238ab8..1fca364 100644
--- a/gcc/lto-streamer-in.c
+++ b/gcc/lto-streamer-in.c
@@ -477,7 +477,7 @@ lto_init_eh (void)
      it.  Since this happens much later than the call to init_eh in
      lang_dependent_init, we have to set flag_exceptions and call
      init_eh again to initialize the EH tables.  */
-  flag_exceptions = 1;
+  GCC_OPTION (flag_exceptions) = 1;
   init_eh ();
 
   eh_initialized_p = true;
@@ -988,7 +988,7 @@ input_function (tree fn_decl, struct data_in *data_in,
 	     We can't remove them earlier because this would cause uid
 	     mismatches in fixups, but we can do it at this point, as
 	     long as debug stmts don't require fixups.  */
-	  if (!MAY_HAVE_DEBUG_STMTS && !flag_wpa && is_gimple_debug (stmt))
+	  if (!MAY_HAVE_DEBUG_STMTS && !GCC_OPTION (flag_wpa) && is_gimple_debug (stmt))
 	    {
 	      gimple_stmt_iterator gsi = bsi;
 	      gsi_next (&bsi);
diff --git a/gcc/lto-streamer-out.c b/gcc/lto-streamer-out.c
index 0f37f1c..9812760 100644
--- a/gcc/lto-streamer-out.c
+++ b/gcc/lto-streamer-out.c
@@ -79,7 +79,7 @@ create_output_block (enum lto_section_type section_type)
   ob->decl_state = lto_get_out_decl_state ();
   ob->main_stream = XCNEW (struct lto_output_stream);
   ob->string_stream = XCNEW (struct lto_output_stream);
-  ob->writer_cache = streamer_tree_cache_create (!flag_wpa, true);
+  ob->writer_cache = streamer_tree_cache_create (!GCC_OPTION (flag_wpa), true);
 
   if (section_type == LTO_section_function_body)
     ob->cfg_stream = XCNEW (struct lto_output_stream);
@@ -875,7 +875,7 @@ hash_tree (struct streamer_tree_cache_d *cache, tree t)
       v = iterative_hash_host_wide_int (TYPE_PRECISION (t), v);
       v = iterative_hash_host_wide_int (TYPE_ALIGN (t), v);
       v = iterative_hash_host_wide_int ((TYPE_ALIAS_SET (t) == 0
-					 || (!in_lto_p
+					 || (!GCC_OPTION (in_lto_p)
 					     && get_alias_set (t) == 0))
 					? 0 : -1, v);
     }
@@ -1237,7 +1237,7 @@ DFS_write_tree (struct output_block *ob, sccs *from_state,
 	     any merging there.  */
 	  hashval_t scc_hash = 0;
 	  unsigned scc_entry_len = 0;
-	  if (!flag_wpa)
+	  if (!GCC_OPTION (flag_wpa))
 	    {
 	      scc_hash = hash_scc (ob->writer_cache, first, size);
 
@@ -1722,7 +1722,7 @@ produce_asm (struct output_block *ob, tree fn)
   else
     section_name = lto_get_section_name (section_type, NULL, NULL);
 
-  lto_begin_section (section_name, !flag_wpa);
+  lto_begin_section (section_name, !GCC_OPTION (flag_wpa));
   free (section_name);
 
   /* The entire header is stream computed here.  */
@@ -1938,7 +1938,7 @@ lto_output_toplevel_asms (void)
   streamer_write_string_cst (ob, ob->main_stream, NULL_TREE);
 
   section_name = lto_get_section_name (LTO_section_asm, NULL, NULL);
-  lto_begin_section (section_name, !flag_wpa);
+  lto_begin_section (section_name, !GCC_OPTION (flag_wpa));
   free (section_name);
 
   /* The entire header stream is computed here.  */
@@ -1984,7 +1984,7 @@ copy_function (struct cgraph_node *node)
   struct lto_in_decl_state *in_state;
   struct lto_out_decl_state *out_state = lto_get_out_decl_state ();
 
-  lto_begin_section (section_name, !flag_wpa);
+  lto_begin_section (section_name, !GCC_OPTION (flag_wpa));
   free (section_name);
 
   /* We may have renamed the declaration, e.g., a static function.  */
@@ -2056,7 +2056,7 @@ lto_output (void)
 #endif
 	  decl_state = lto_new_out_decl_state ();
 	  lto_push_out_decl_state (decl_state);
-	  if (gimple_has_body_p (node->decl) || !flag_wpa)
+	  if (gimple_has_body_p (node->decl) || !GCC_OPTION (flag_wpa))
 	    output_function (node);
 	  else
 	    copy_function (node);
@@ -2415,7 +2415,7 @@ produce_asm_for_decls (void)
   memset (&header, 0, sizeof (struct lto_decl_header));
 
   section_name = lto_get_section_name (LTO_section_decls, NULL, NULL);
-  lto_begin_section (section_name, !flag_wpa);
+  lto_begin_section (section_name, !GCC_OPTION (flag_wpa));
   free (section_name);
 
   /* Make string 0 be a NULL string.  */
@@ -2483,7 +2483,7 @@ produce_asm_for_decls (void)
 
   /* Write the symbol table.  It is used by linker to determine dependencies
      and thus we can skip it for WPA.  */
-  if (!flag_wpa)
+  if (!GCC_OPTION (flag_wpa))
     produce_symtab (ob);
 
   /* Write command line opts.  */
diff --git a/gcc/lto-streamer.c b/gcc/lto-streamer.c
index e94b787..375584f 100644
--- a/gcc/lto-streamer.c
+++ b/gcc/lto-streamer.c
@@ -204,7 +204,7 @@ print_lto_report (const char *s)
 	       HOST_WIDE_INT_PRINT_UNSIGNED "\n", s,
 	       get_tree_code_name ((enum tree_code) i), lto_stats.num_trees[i]);
 
-  if (flag_lto)
+  if (GCC_OPTION (flag_lto))
     {
       fprintf (stderr, "[%s] Compression: "
 	       HOST_WIDE_INT_PRINT_UNSIGNED " output bytes, "
@@ -220,7 +220,7 @@ print_lto_report (const char *s)
       fprintf (stderr, "\n");
     }
 
-  if (flag_wpa)
+  if (GCC_OPTION (flag_wpa))
     {
       fprintf (stderr, "[%s] # of output files: "
 	       HOST_WIDE_INT_PRINT_UNSIGNED "\n", s,
@@ -314,7 +314,7 @@ lto_streamer_init (void)
 bool
 gate_lto_out (void)
 {
-  return ((flag_generate_lto || in_lto_p)
+  return ((GCC_OPTION (flag_generate_lto) || GCC_OPTION (in_lto_p))
 	  /* Don't bother doing anything if the program has errors.  */
 	  && !seen_error ());
 }
diff --git a/gcc/lto/lto-lang.c b/gcc/lto/lto-lang.c
index f60d212..525c8d6 100644
--- a/gcc/lto/lto-lang.c
+++ b/gcc/lto/lto-lang.c
@@ -578,8 +578,8 @@ def_builtin_1 (enum built_in_function fncode, const char *name,
 			       fnattrs);
 
   if (both_p
-      && !flag_no_builtin
-      && !(nonansi_p && flag_no_nonansi_builtin))
+      && !GCC_OPTION (flag_no_builtin)
+      && !(nonansi_p && GCC_OPTION (flag_no_nonansi_builtin)))
     add_builtin_function (libname, libtype, fncode, fnclass,
 			  NULL, fnattrs);
 
@@ -746,11 +746,11 @@ lto_handle_option (size_t scode, const char *arg,
       break;
 
     case OPT_Wabi:
-      warn_psabi = value;
+      GCC_OPTION (warn_psabi) = value;
       break;
 
     case OPT_fwpa:
-      flag_wpa = value ? "" : NULL;
+      GCC_OPTION (flag_wpa) = value ? "" : NULL;
       break;
 
     default:
@@ -768,24 +768,24 @@ static bool
 lto_post_options (const char **pfilename ATTRIBUTE_UNUSED)
 {
   /* -fltrans and -fwpa are mutually exclusive.  Check for that here.  */
-  if (flag_wpa && flag_ltrans)
+  if (GCC_OPTION (flag_wpa) && GCC_OPTION (flag_ltrans))
     error ("-fwpa and -fltrans are mutually exclusive");
 
-  if (flag_ltrans)
+  if (GCC_OPTION (flag_ltrans))
     {
-      flag_generate_lto = 0;
+      GCC_OPTION (flag_generate_lto) = 0;
 
       /* During LTRANS, we are not looking at the whole program, only
 	 a subset of the whole callgraph.  */
-      flag_whole_program = 0;
+      GCC_OPTION (flag_whole_program) = 0;
     }
 
-  if (flag_wpa)
-    flag_generate_lto = 1;
+  if (GCC_OPTION (flag_wpa))
+    GCC_OPTION (flag_generate_lto) = 1;
 
   /* Excess precision other than "fast" requires front-end
      support.  */
-  flag_excess_precision_cmdline = EXCESS_PRECISION_FAST;
+  GCC_OPTION (flag_excess_precision_cmdline) = EXCESS_PRECISION_FAST;
 
   /* Initialize the compiler back end.  */
   return false;
@@ -1079,7 +1079,7 @@ lto_getdecls (void)
 static void
 lto_write_globals (void)
 {
-  if (flag_wpa)
+  if (GCC_OPTION (flag_wpa))
     return;
 
   /* Output debug info for global variables.  */  
@@ -1155,10 +1155,10 @@ static bool
 lto_init (void)
 {
   /* We need to generate LTO if running in WPA mode.  */
-  flag_generate_lto = (flag_wpa != NULL);
+  GCC_OPTION (flag_generate_lto) = (GCC_OPTION (flag_wpa) != NULL);
 
   /* Create the basic integer types.  */
-  build_common_tree_nodes (flag_signed_char, flag_short_double);
+  build_common_tree_nodes (GCC_OPTION (flag_signed_char), GCC_OPTION (flag_short_double));
 
   /* The global tree for the main identifier is filled in by
      language-specific front-end initialization that is not run in the
@@ -1190,7 +1190,7 @@ lto_init (void)
 			   build_reference_type (va_list_type_node));
     }
   
-  if (flag_cilkplus)
+  if (GCC_OPTION (flag_cilkplus))
     cilk_init_builtins ();
 
   targetm.init_builtins ();
@@ -1230,7 +1230,7 @@ lto_init (void)
 #undef NAME_TYPE
 
   /* Initialize LTO-specific data structures.  */
-  in_lto_p = true;
+  GCC_OPTION (in_lto_p) = true;
 
   return true;
 }
diff --git a/gcc/lto/lto-partition.c b/gcc/lto/lto-partition.c
index 1ee5fbb..3dac576 100644
--- a/gcc/lto/lto-partition.c
+++ b/gcc/lto/lto-partition.c
@@ -350,7 +350,7 @@ node_cmp (const void *pa, const void *pb)
      of a function. All functions with profile are placed in ascending
      order at the beginning.  */
 
-  if (flag_profile_reorder_functions)
+  if (GCC_OPTION (flag_profile_reorder_functions))
   {
     /* Functions with time profile are sorted in ascending order.  */
     if (a->tp_first_run && b->tp_first_run)
@@ -456,7 +456,7 @@ lto_balanced_map (void)
     for(i = 0; i < n_nodes; i++)
       fprintf (cgraph_dump_file, "Balanced map symbol order:%s:%u\n", order[i]->name (), order[i]->tp_first_run);
 
-  if (!flag_toplevel_reorder)
+  if (!GCC_OPTION (flag_toplevel_reorder))
     {
       FOR_EACH_VARIABLE (vnode)
 	if (symtab_get_symbol_partitioning_class (vnode) == SYMBOL_PARTITION)
@@ -488,7 +488,7 @@ lto_balanced_map (void)
 
       current_order = order[i]->order;
 
-      if (!flag_toplevel_reorder)
+      if (!GCC_OPTION (flag_toplevel_reorder))
 	while (varpool_pos < n_varpool_nodes
 	       && varpool_order[varpool_pos]->order < current_order)
 	  {
@@ -584,7 +584,7 @@ lto_balanced_map (void)
 		vnode = ipa_ref_varpool_node (ref);
 		if (!vnode->definition)
 		  continue;
-		if (!symbol_partitioned_p (vnode) && flag_toplevel_reorder
+		if (!symbol_partitioned_p (vnode) && GCC_OPTION (flag_toplevel_reorder)
 		    && symtab_get_symbol_partitioning_class (vnode) == SYMBOL_PARTITION)
 		  add_symbol_to_partition (partition, vnode);
 		index = lto_symtab_encoder_lookup (partition->encoder,
@@ -620,7 +620,7 @@ lto_balanced_map (void)
 		/* It is better to couple variables with their users, because it allows them
 		   to be removed.  Coupling with objects they refer to only helps to reduce
 		   number of symbols promoted to hidden.  */
-		if (!symbol_partitioned_p (vnode) && flag_toplevel_reorder
+		if (!symbol_partitioned_p (vnode) && GCC_OPTION (flag_toplevel_reorder)
 		    && !varpool_can_remove_if_no_refs (vnode)
 		    && symtab_get_symbol_partitioning_class (vnode) == SYMBOL_PARTITION)
 		  add_symbol_to_partition (partition, vnode);
@@ -712,7 +712,7 @@ lto_balanced_map (void)
     }
 
   /* Varables that are not reachable from the code go into last partition.  */
-  if (flag_toplevel_reorder)
+  if (GCC_OPTION (flag_toplevel_reorder))
     {
       FOR_EACH_VARIABLE (vnode)
         if (symtab_get_symbol_partitioning_class (vnode) == SYMBOL_PARTITION
@@ -893,7 +893,7 @@ lto_promote_cross_file_statics (void)
 {
   unsigned i, n_sets;
 
-  gcc_assert (flag_wpa);
+  gcc_assert (GCC_OPTION (flag_wpa));
 
   /* First compute boundaries.  */
   n_sets = ltrans_partitions.length ();
